<template>
  <a-modal
    title="门牌管理"
    style="top: 20px;"
    :width="1100"
    v-model="visible"
    :footer="null"

  >
    <div class="table-operator">
      <a-button type="primary" icon="plus" @click="$refs.modal.add(addressId)">新建</a-button>
      <a-dropdown v-if="selectedRowKeys.length > 0">
        <a-button type="danger" icon="delete" @click="delByIds(selectedRowKeys)">删除</a-button>
      </a-dropdown>
    </div>
    <s-table
      size="default"
      ref="table"
      rowKey="id"
      :rowSelection="{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}"
      :columns="columns"
      :data="loadData"
    >
      <span slot="action" slot-scope="text, record">
        <a @click="handleEdit(record)">编辑</a>
        <a-divider type="vertical" />
        <a @click="delByIds([record.id])">删除</a>
      </span>
    </s-table>
    <repair-address-floor-modal ref="modal" @ok="handleOk"/>
  </a-modal>
</template>
<script>
import { STable } from '@/components'
import { delRepairRoom, getRepairRoomList } from '@/api/admin/repair/repairAddressFloor'
import RepairAddressFloorModal from './RepairAddressFloorModal.vue'
import { checkPermission } from '@/utils/permissions'
import RepairAddressModal from '@/views/admin/repair/modules/RepairAddressModal'

    export default {
  name: 'RepairRoomListModal',
  props: {
  },
  components: {
    RepairAddressModal,
    STable,
    RepairAddressFloorModal
  },
  data () {
    return {
      visible: false,
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      },
      form: this.$form.createForm(this),
      mdl: {},
      // 高级搜索 展开/关闭
      advanced: false,
      // 查询参数
      queryParam: {},
      addressId: '',
      // 表头
      columns: [
        {
          title: '楼层',
          dataIndex: 'name'
        },
        {
          title: '网格长',
          dataIndex: 'adminName'
        },
        {
          title: '备注',
          dataIndex: 'remark'
        },

        {
          title: '操作',
          width: '200px',
          dataIndex: 'action',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        return getRepairRoomList(Object.assign(parameter, this.queryParam))
      },
      selectedRowKeys: [],
      selectedRows: [],
      addEnable: checkPermission('floor:floor:add'),
      editEnabel: checkPermission('floor:floor:edit'),
      removeEnable: checkPermission('floor:floor:remove')
    }
  },
  beforeCreate () {
  },
  created () {
  },
  methods: {
    show (addressId) {
      this.visible = true
      this.addressId = addressId
      this.queryParam.addressId = addressId

      this.$refs.table && this.$refs.table.refresh(true)
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    handleAdd () {
      this.$refs.modal.add()
    },
    handleEdit (record) {
      this.$refs.modal.edit(record)
    },
    handleOk () {
      this.$refs.table.refresh(true)
      console.log('handleSaveOk')
    },
    delByIds (ids) {
      delRepairRoom({ ids: ids.join(',') }).then(res => {
        if (res.code === 0) {
          this.$message.success('删除成功')
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    }
  },
  watch: {
    /*
      'selectedRows': function (selectedRows) {
        this.needTotalList = this.needTotalList.map(item => {
          return {
            ...item,
            total: selectedRows.reduce( (sum, val) => {
              return sum + val[item.dataIndex]
            }, 0)
          }
        })
      }
      */
  }
}
</script>
